package cz.cvut.kbss.reporting.model;

import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Embedded;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;
import javax.persistence.OrderBy;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
@Entity
public class Occurrence extends Event {

    @Basic(optional = false)
    @Column(nullable = false)
    private String name;

    @Embedded
    private EventInfo time;

    @Enumerated(EnumType.STRING)    // Use an enum for demonstration purposes
    @Basic(optional = false)
    @Column(nullable = false)
    private Severity severity;

    @OrderBy("type")
    @OneToMany(fetch = FetchType.EAGER, cascade = CascadeType.ALL, orphanRemoval = true)
    private List<Event> parts;  // Subevents of the occurrence

    @Override
    public String toString() {
        return "Occurrence{" + name +
                "<" + time +
                ">, severity=" + severity +
                ", type=" + getType() +
                "}";
    }
}
