package cz.cvut.kbss.reporting.model;

import java.time.LocalDateTime;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.SecondaryTable;
import javax.persistence.SecondaryTables;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
@Entity
@NamedQueries({@NamedQuery(name = "Tag.findByName", query = "SELECT t FROM Tag t WHERE t.name = :name")})
@SecondaryTables({
    @SecondaryTable(name = "changemetadata")
})
public class Tag extends AbstractEntity {

    @Basic(optional = false)
    @Column(nullable = false, length = 20)
    private String name;

    @Basic(optional = false)
    @Column(nullable = false, table="changemetadata",name="createdtime")
    @Temporal(TemporalType.TIMESTAMP)
    private LocalDateTime created;

    @JoinColumn(nullable = false, name = "AUTHOR_ID", table="changemetadata")
    @ManyToOne(optional = false, fetch = FetchType.EAGER)
    private Person author;

    @Override
    public String toString() {
        return name + " (" + created + ")";
    }
}
